#version 430 core
/*
* Copyright 2010 Vienna University of Technology.
* Institute of Computer Graphics and Algorithms.
* This file is part of the ECG Lab Framework and must not be redistributed.
*/

layout(location = 0) in vec3 position;
layout(location = 1) in vec3 normal;
layout(location = 2) in vec2 uv;

out VertexData {
	vec3 position_world;
	vec3 normal_world;
	vec3 color_world;
	vec2 uv_world;
} vert;

uniform mat4 modelMatrix;
uniform mat4 viewProjMatrix;

void main() {
	gl_Position = modelMatrix * vec4(position, 1);
	vert.position_world = vec3(modelMatrix * vec4(position, 1));

	vert.normal_world = vec3(transpose(inverse(modelMatrix)) * vec4(normal, 1)); // normals fix
	vert.normal_world = normalize(vert.normal_world);
	
	vert.uv_world = uv;
}
	
	
	
	