#version 430 core

uniform struct Matrices
{
mat4 proj;
mat4 view;
}matrices;

uniform mat4 mvp;
uniform vec3 camera_pos;
uniform vec3 quad1, quad2;

layout(points) in;
layout (triangle_strip) out;
//layout(points) out;
layout (max_vertices = 4) out;

in vec3 positionPass[];
in vec3 colorPass[];
in float lifeTimePass[];
in float sizePass[];
in int typePass[];

out vec3 colorOut;

smooth out vec2 textCoords;
flat out vec4 colorPart;

void main () {

//colorOut = vec3(0,0,1);//colorPass[0];
//gl_Position = mvp*vec4(positionPass[0],1);
//EmitVertex();
//EndPrimitive(); 


 if(typePass[0] != 0)
  {
    vec3 vPosOld = gl_in[0].gl_Position.xyz;
	
	//vec3 direction = gl_Position.xyz-camera_pos;
	
    float fSize = sizePass[0];
    mat4 mVP = mvp;//matrices.proj*matrices.view;
	
    //colorPart = vec4(colorPass[0], lifeTimePass[0]/10000);
	colorPart = vec4(colorPass[0], 1);
       
    vec3 vPos = vPosOld+(-quad1-quad2)*fSize;
    textCoords = vec2(0.0, 0.0);
    gl_Position = mVP*vec4(vPos, 1.0);
    EmitVertex();
    
    vPos = vPosOld+(-quad1+quad2)*fSize;
    textCoords = vec2(0.0, 1.0);
    gl_Position = mVP*vec4(vPos, 1.0);
    EmitVertex();
    
    vPos = vPosOld+(quad1-quad2)*fSize;
    textCoords = vec2(1.0, 0.0);
    gl_Position = mVP*vec4(vPos, 1.0);
    EmitVertex();
    
    vPos = vPosOld+(quad1+quad2)*fSize;
    textCoords = vec2(1.0, 1.0);
    gl_Position = mVP*vec4(vPos, 1.0);
    EmitVertex();
      
    EndPrimitive();
  }
}
